
; PicBasic Pro Compiler 2.10,  Copyright (c) 1998 microEngineering Labs, Inc.     All Rights Reserved.

PM_USED			EQU	1

	INCLUDE	"PBPPROC.INC"

RAM_START       		EQU	0000Ch
RAM_END         		EQU	0004Fh
RAM_BANKS       		EQU	00001h
BANK0_START     		EQU	0000Ch
BANK0_END       		EQU	0004Fh
EEPROM_START    		EQU	02100h
EEPROM_END      		EQU	0213Fh

R0              		EQU	RAM_START + 000h
R1              		EQU	RAM_START + 002h
R2              		EQU	RAM_START + 004h
R3              		EQU	RAM_START + 006h
R4              		EQU	RAM_START + 008h
R5              		EQU	RAM_START + 00Ah
R6              		EQU	RAM_START + 00Ch
R7              		EQU	RAM_START + 00Eh
R8              		EQU	RAM_START + 010h
T1              		EQU	RAM_START + 012h
FLAGS           		EQU	RAM_START + 014h
GOP             		EQU	RAM_START + 015h
RM1             		EQU	RAM_START + 016h
RM2             		EQU	RAM_START + 017h
RR1             		EQU	RAM_START + 018h
RR2             		EQU	RAM_START + 019h
_I               		EQU	RAM_START + 01Ah
_ID              		EQU	RAM_START + 01Bh
_ID1             		EQU	RAM_START + 01Ch
_ID2             		EQU	RAM_START + 01Dh
_ID3             		EQU	RAM_START + 01Eh
_ID4             		EQU	RAM_START + 01Fh
_L               		EQU	RAM_START + 020h
_M               		EQU	RAM_START + 021h
_N               		EQU	RAM_START + 022h
_SD              		EQU	RAM_START + 023h
_PORTL           		EQU	PORTB
_PORTH           		EQU	PORTA
_TRISL           		EQU	TRISB
_TRISH           		EQU	TRISA
#define _PORTB_1         	PORTB, 001h
#define _PORTB_2         	PORTB, 002h
#define _PORTB_0         	PORTB, 000h

; Constants.
_T2400           		EQU	00000h
_T1200           		EQU	00001h
_T9600           		EQU	00002h
_T300            		EQU	00003h
_N2400           		EQU	00004h
_N1200           		EQU	00005h
_N9600           		EQU	00006h
_N300            		EQU	00007h
_OT2400          		EQU	00008h
_OT1200          		EQU	00009h
_OT9600          		EQU	0000Ah
_OT300           		EQU	0000Bh
_ON2400          		EQU	0000Ch
_ON1200          		EQU	0000Dh
_ON9600          		EQU	0000Eh
_ON300           		EQU	0000Fh
_MSBPRE          		EQU	00000h
_LSBPRE          		EQU	00001h
_MSBPOST         		EQU	00002h
_LSBPOST         		EQU	00003h
_LSBFIRST        		EQU	00000h
_MSBFIRST        		EQU	00001h
_CLS             		EQU	00000h
_HOME            		EQU	00001h
_BELL            		EQU	00007h
_BKSP            		EQU	00008h
_TAB             		EQU	00009h
_CR              		EQU	0000Dh
_unitOn          		EQU	00012h
_unitOff         		EQU	0001Ah
_unitsOff        		EQU	0001Ch
_lightsOn        		EQU	00014h
_lightsOff       		EQU	00010h
_dim             		EQU	0001Eh
_bright          		EQU	00016h
	INCLUDE	"TCPRX.MAC"
	INCLUDE	"PBPPIC14.LIB"

	CLEAR?	
	OUTPUT?T	_PORTB_1
	OUTPUT?T	_PORTB_2
	MOVE?CB	000h, _I
	MOVE?CB	000h, _L
	MOVE?CB	000h, _M
	MOVE?CB	000h, _N
	MOVE?CB	016h, _ID
	MOVE?CB	046h, _ID1
	MOVE?CB	050h, _ID2
	MOVE?CB	05Ah, _ID3
	MOVE?CB	064h, _ID4
	MOVE?CT	000h, _PORTB_1
	MOVE?CT	000h, _PORTB_2

	LABEL?L	_loop	
	MOVE?CB	000h, _SD
	SERPIN?T	_PORTB_0
	SERMODE?C	_N300

	LABEL?L	L00001	
	SERINQ?BL	_ID, L00001
	SERIN?B	_SD
	CMPEQ?BBB	_SD, _ID1, T1
	CMPF?BL	T1, L00002
	ADD?BCB	_I, 001h, _I
	CMPEQ?BCB	_I, 014h, T1
	CMPF?BL	T1, L00004
	MOVE?CT	001h, _PORTB_1
	MOVE?CB	000h, _I
	LABEL?L	L00004	
	LABEL?L	L00002	
	CMPEQ?BBB	_SD, _ID2, T1
	CMPF?BL	T1, L00006
	ADD?BCB	_L, 001h, _L
	CMPEQ?BCB	_L, 014h, T1
	CMPF?BL	T1, L00008
	MOVE?CT	000h, _PORTB_1
	MOVE?CB	000h, _L
	LABEL?L	L00008	
	LABEL?L	L00006	
	CMPEQ?BBB	_SD, _ID3, T1
	CMPF?BL	T1, L00010
	ADD?BCB	_M, 001h, _M
	CMPEQ?BCB	_M, 014h, T1
	CMPF?BL	T1, L00012
	MOVE?CT	001h, _PORTB_2
	MOVE?CB	000h, _M
	LABEL?L	L00012	
	LABEL?L	L00010	
	CMPEQ?BBB	_SD, _ID4, T1
	CMPF?BL	T1, L00014
	ADD?BCB	_N, 001h, _N
	CMPEQ?BCB	_N, 014h, T1
	CMPF?BL	T1, L00016
	MOVE?CT	000h, _PORTB_2
	MOVE?CB	000h, _N
	LABEL?L	L00016	
	LABEL?L	L00014	
	GOTO?L	_loop

	END
